// Hauptprogramm
// RC5 Sender
// Sendet fnf verschiedene Codes
//
// Copyright 2000 by Holger Klabunde
// 30.04.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */

#include "rc5send.h" //Pindefinitionen
#include "protos.h"

#include "interupt.c"
#include "initpic.c"
#include "delay.c"
#include "phasemod.c"

//Globale Flags und Rckgabevariablen

unsigned char tastbuf;  //Tastaturpuffer fr lesen im INT
unsigned char toggle;   //Togglebit
unsigned char togglemask; //Merkt sich die Togglbits der Tasten
unsigned char comcode;  //Kommandocode

/* Hauptprogramm */
void main()
{
 unsigned char i,buf;
 
 InitPIC(); //Interrupts und so weiter einstellen

 togglemask=0;

 while(1) // Anfang Programm Endlosschleife
  {
   tastbuf=0; //Letzten Tastencode lschen
   GIE=1; //Interrupts erlauben
   RBIF=0; //Nochmal lschen falls wieder gesetzt
   INTF=0; //Nochmal lschen falls wieder gesetzt

   SLEEP;      //Schlafen bis Taste gedrckt wird
   NOP;      //Beim aufwachen erstmal nix tun
   
   while(GIE) GIE=0; //Zur Auswertung Int. verbieten

//Tastatur auswerten
   switch(tastbuf)
    {
     case KEY7: comcode=7;     break;
     case KEY6: comcode=6;     break;
     case KEY5: comcode=5;     break;
     case KEY4: comcode=4;     break;
     case KEY3: comcode=3;     break;
     default:   comcode=0;     break; //Ungltiger Kommandocode
    }   

    
   //Zur Sicherheit nur bei gltigen Kommandos weitermachen
   //z.B. wenn Taste losgelassen wird !!! Dann nicht senden
   if(comcode>2)
    {

     //Togglebit der Taste merken bzw. verndern
     buf=0x01<<comcode; //Togglebit auf richtige Position schieben
     if(togglemask&buf) //Togglebit Gesetzt ?
      {
       togglemask&=~buf; //Dann lschen
       toggle=0;         //Neues Togglebit
      }
     else //War nicht gesetzt
      {
       togglemask|=buf; //Dann setzen
       toggle=1;        //Neues Togglebit
      }
      
     for(i=0; i<5; i++) PhaseMod(); //Codes 5x phasenmoduliert senden

    }//if comcode
    
 
  } // Ende Programm Endlosschleife
}

